<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kd7w2jm6rvvx6pnfgbmafdxkx875y5cf-vendored-sources/unwinding-0.1.4/src/unwinder/arch/aarch64.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>aarch64.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../../storage.js"></script><script defer src="../../../../source-script.js"></script><script defer src="../../../../source-files.js"></script><script defer src="../../../../main.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../../unwinding/index.html"><div class="logo-container"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../../unwinding/index.html"><img class="rust-logo" src="../../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::arch::asm</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>;
<span class="kw">use</span> <span class="ident">core::ops</span>;
<span class="kw">use</span> <span class="ident">gimli</span>::{<span class="ident">AArch64</span>, <span class="ident">Register</span>};

<span class="comment">// Match DWARF_FRAME_REGISTERS in libgcc</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">MAX_REG_RULES</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">97</span>;

<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Default</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Context</span> {
    <span class="kw">pub</span> <span class="ident">gp</span>: [<span class="ident">usize</span>; <span class="number">31</span>],
    <span class="kw">pub</span> <span class="ident">sp</span>: <span class="ident">usize</span>,
    <span class="kw">pub</span> <span class="ident">fp</span>: [<span class="ident">usize</span>; <span class="number">32</span>],
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Context</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">fmt</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">fmt</span> <span class="op">=</span> <span class="ident">fmt</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Context&quot;</span>);
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="op">=</span><span class="number">30</span> {
            <span class="ident">fmt</span>.<span class="ident">field</span>(
                <span class="ident">AArch64::register_name</span>(<span class="ident">Register</span>(<span class="ident">i</span> <span class="kw">as</span> <span class="kw">_</span>)).<span class="ident">unwrap</span>(),
                <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">gp</span>[<span class="ident">i</span>],
            );
        }
        <span class="ident">fmt</span>.<span class="ident">field</span>(<span class="string">&quot;sp&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">sp</span>);
        <span class="kw">for</span> <span class="ident">i</span> <span class="kw">in</span> <span class="number">0</span>..<span class="op">=</span><span class="number">31</span> {
            <span class="ident">fmt</span>.<span class="ident">field</span>(
                <span class="ident">AArch64::register_name</span>(<span class="ident">Register</span>((<span class="ident">i</span> <span class="op">+</span> <span class="number">64</span>) <span class="kw">as</span> <span class="kw">_</span>)).<span class="ident">unwrap</span>(),
                <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">fp</span>[<span class="ident">i</span>],
            );
        }
        <span class="ident">fmt</span>.<span class="ident">finish</span>()
    }
}

<span class="kw">impl</span> <span class="ident">ops::Index</span><span class="op">&lt;</span><span class="ident">Register</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Context</span> {
    <span class="kw">type</span> <span class="ident">Output</span> <span class="op">=</span> <span class="ident">usize</span>;

    <span class="kw">fn</span> <span class="ident">index</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">reg</span>: <span class="ident">Register</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">usize</span> {
        <span class="kw">match</span> <span class="ident">reg</span> {
            <span class="ident">Register</span>(<span class="number">0</span>..<span class="op">=</span><span class="number">30</span>) =&gt; <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">gp</span>[<span class="ident">reg</span>.<span class="number">0</span> <span class="kw">as</span> <span class="ident">usize</span>],
            <span class="ident">AArch64::SP</span> =&gt; <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">sp</span>,
            <span class="ident">Register</span>(<span class="number">64</span>..<span class="op">=</span><span class="number">95</span>) =&gt; <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">fp</span>[(<span class="ident">reg</span>.<span class="number">0</span> <span class="op">-</span> <span class="number">64</span>) <span class="kw">as</span> <span class="ident">usize</span>],
            <span class="kw">_</span> =&gt; <span class="macro">unimplemented!</span>(),
        }
    }
}

<span class="kw">impl</span> <span class="ident">ops::IndexMut</span><span class="op">&lt;</span><span class="ident">gimli::Register</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Context</span> {
    <span class="kw">fn</span> <span class="ident">index_mut</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">reg</span>: <span class="ident">Register</span>) -&gt; <span class="kw-2">&amp;mut</span> <span class="ident">usize</span> {
        <span class="kw">match</span> <span class="ident">reg</span> {
            <span class="ident">Register</span>(<span class="number">0</span>..<span class="op">=</span><span class="number">30</span>) =&gt; <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">gp</span>[<span class="ident">reg</span>.<span class="number">0</span> <span class="kw">as</span> <span class="ident">usize</span>],
            <span class="ident">AArch64::SP</span> =&gt; <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">sp</span>,
            <span class="ident">Register</span>(<span class="number">64</span>..<span class="op">=</span><span class="number">95</span>) =&gt; <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">fp</span>[(<span class="ident">reg</span>.<span class="number">0</span> <span class="op">-</span> <span class="number">64</span>) <span class="kw">as</span> <span class="ident">usize</span>],
            <span class="kw">_</span> =&gt; <span class="macro">unimplemented!</span>(),
        }
    }
}

<span class="attribute">#[<span class="ident">naked</span>]</span>
<span class="kw">pub</span> <span class="kw">extern</span> <span class="string">&quot;C-unwind&quot;</span> <span class="kw">fn</span> <span class="ident">save_context</span>() -&gt; <span class="ident">Context</span> {
    <span class="comment">// No need to save caller-saved registers here.</span>
    <span class="kw">unsafe</span> {
        <span class="macro">asm!</span>(
            <span class="string">&quot;
            stp d8, d9, [x8, 0x140]
            stp d10, d11, [x8, 0x150]
            stp d12, d13, [x8, 0x160]
            stp d14, d15, [x8, 0x170]

            str x19, [x8, 0x98]
            stp x20, x21, [x8, 0xA0]
            stp x22, x23, [x8, 0xB0]
            stp x24, x25, [x8, 0xC0]
            stp x26, x27, [x8, 0xD0]
            stp x28, x29, [x8, 0xE0]
            mov x0, sp
            stp x30, x0, [x8, 0xF0]

            ret
            &quot;</span>,
            <span class="ident">options</span>(<span class="ident">noreturn</span>)
        );
    }
}

<span class="attribute">#[<span class="ident">naked</span>]</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> <span class="kw">fn</span> <span class="ident">restore_context</span>(<span class="ident">ctx</span>: <span class="kw-2">&amp;</span><span class="ident">Context</span>) -&gt; <span class="op">!</span> {
    <span class="kw">unsafe</span> {
        <span class="macro">asm!</span>(
            <span class="string">&quot;
            ldp d0, d1, [x0, 0x100]
            ldp d2, d3, [x0, 0x110]
            ldp d4, d5, [x0, 0x120]
            ldp d6, d7, [x0, 0x130]
            ldp d8, d9, [x0, 0x140]
            ldp d10, d11, [x0, 0x150]
            ldp d12, d13, [x0, 0x160]
            ldp d14, d15, [x0, 0x170]
            ldp d16, d17, [x0, 0x180]
            ldp d18, d19, [x0, 0x190]
            ldp d20, d21, [x0, 0x1A0]
            ldp d22, d23, [x0, 0x1B0]
            ldp d24, d25, [x0, 0x1C0]
            ldp d26, d27, [x0, 0x1D0]
            ldp d28, d29, [x0, 0x1E0]
            ldp d30, d31, [x0, 0x1F0]

            ldp x2, x3, [x0, 0x10]
            ldp x4, x5, [x0, 0x20]
            ldp x6, x7, [x0, 0x30]
            ldp x8, x9, [x0, 0x40]
            ldp x10, x11, [x0, 0x50]
            ldp x12, x13, [x0, 0x60]
            ldp x14, x15, [x0, 0x70]
            ldp x16, x17, [x0, 0x80]
            ldp x18, x19, [x0, 0x90]
            ldp x20, x21, [x0, 0xA0]
            ldp x22, x23, [x0, 0xB0]
            ldp x24, x25, [x0, 0xC0]
            ldp x26, x27, [x0, 0xD0]
            ldp x28, x29, [x0, 0xE0]
            ldp x30, x1, [x0, 0xF0]
            mov sp, x1

            ldp x0, x1, [x0, 0x00]
            ret
            &quot;</span>,
            <span class="ident">options</span>(<span class="ident">noreturn</span>)
        );
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../../" data-current-crate="unwinding" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>